// $Id$

/***************************************************************************
*   Copyright (C) 2004 by Thomas Fischer                                  *
*   fischer@unix-ag.uni-kl.de                                             *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef KBIBTEXENTRYWIDGET_H
#define KBIBTEXENTRYWIDGET_H

#include <kbibtexentrywidgetui.h>

class QSpinBox;
class QStringList;
class BibTeXEntry;
class BibTeXFile;

/**
@author Thomas Fischer
*/
class KBibTeXEntryWidget : public KBibTeXEntryWidgetUI
{
    Q_OBJECT
public:
    KBibTeXEntryWidget( BibTeXEntry *entry, BibTeXFile *bibtexfile, QWidget *parent = 0, const char *name = 0 );

    ~KBibTeXEntryWidget();

    static QDialog::DialogCode execute( BibTeXEntry *entry, BibTeXFile *bibtexfile, const QString& caption, QWidget *parent = 0, const char *name = 0 );

private:
    enum WidgetStatus {wsRequired, wsOptional, wsUnused};
    BibTeXEntry *m_entry;
    BibTeXFile *m_bibtexfile;
    bool m_enableAllFields;
    QStringList *deletedUserFields;

    void setupGUI();
    void setupEntryTypes();
    void getEntryData();
    bool setEntryDataSpinBox( QSpinBox *sbx, BibTeXEntry::FieldType fieldType );
    bool setEntryDataText( QString text, BibTeXEntry::FieldType fieldType );
    bool setEntryData();
    void changeElementType( BibTeXElement::ElementType elementType );
    void setWidgetStatus( QWidget* widget, BibTeXEntry::FieldRequireStatus requiredStatus );
    void getUserFields();

private slots:
    void slotOk();
    void slotEntryTypeChanged( int index );
    void slotEnableAllFields( bool enable );
    void slotUserFieldExecute( QListViewItem* item = NULL );
    void slotUserNameChanged( const QString& newText );
    void slotUserAddClicked( );
    void slotUserDeleteClicked();
    void slotApplyURLtoNode();
    void slotAddAuthor();
    void slotRemoveAuthor();
    void slotUpAuthor();
    void slotDownAuthor();
    void slotAddEditor();
    void slotRemoveEditor();
    void slotUpEditor();
    void slotDownEditor();
    void slotUpdateAuthorEditorUI();
    void slotSelectStringJournal();
};

#endif
